import mapMod
import objMod
import libtcodpy as libtcod
import wininiMod
import math

###### ######
### MECHS ###
###### ######
     
class Mech:
     def __init__(self, name, tonnage, move_p, heatsinks, hp, price, char, x, y, color):
          self.name = name
          self.tonnage = tonnage
          self.heatsinks = heatsinks
          self.hp = hp
          self.price = price
          self.char = char
          self.color = color
          self.move_p = move_p
          self.x = x
          self.y = y

     def __str__(self):
          return 'Name: ' + self.name + ' = ' + repr(self.tonnage) + ' hp = ' + repr(self.hp) + ' Heatsinks: ' + repr(self.heatsinks) + ' Price = ' + repr(self.price)
# map_test.squares[self.x + dx][self.y + dy].blocked and

     def mech_move(self, map_test,dx, dy):
          
          if map_test.squares[self.x + dx][self.y + dy].blocked == None and map_test.squares[self.x + dx][self.y + dy].level - map_test.squares[self.x][self.y].level < 2 and self.move_p > 0:
               self.x = self.x + dx
               self.y = self.y + dy

          else:
               self.x = self.x
               self.y = self.y
               #self.move_p = self.move_p - 1
               
          #elif self.move_p > 0:
               #self.move_p = self.move_p - 1

     def refill_move_p(self):
          self.move_p = 5


     def draw(self):
               libtcod.console_set_default_foreground(0, self.color)
               libtcod.console_put_char(0, self.x, self.y, self.char, libtcod.BKGND_NONE)

     def clear(self):
          libtcod.console_put_char(0, self.x, self.y, ' ', libtcod.BKGND_NONE)

def blocked_tile():
     pass


     


##########
# PRICES #
##########
     
#Light#

ant_price           = 1512400
bee_price      = 1646640
gnat_price          = 1615440
stubblerunner_price = 1891250
louse_price         = 2259952
beetle_price        = 2984540
moth_price          = 1471925
siren_price      = 2205320
spark_price   = 3046950
newt_price        = 3198375
bumblebee_price       = 3416760
hornet_price       = 2485710



#########
# LIGHT #
#########

class Locust(Mech):
     def __init__(self,hp):
#                             name(*), tonnage(*), mp_walk(*), mp_run(*), heatsinks(*), health, price(*), char(*), color(*)
          Mech.__init__(self,'Ant', 20, 5, 10, hp, ant_price, 'A', 20, 1, libtcod.white)

class Wasp(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Bee', 20, 10, hp, bee_price, 'H', libtcod.white)

class Stinger(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Gnat', 20, 10, hp, gnat_price, 'G', libtcod.white)

class Commando(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Stubblerunner', 25, 10, hp, stubblerunner_price, 'S', libtcod.white)

class Javelin(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Louse', 30, 10, hp, louse_price, 'L', libtcod.light_grey)

class Spider(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Beetle', 30, 10, hp, beetle_price, 'B', libtcod.light_grey)

class UrbanMech(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Moth', 30, 11, hp, moth_price, 'M', libtcod.light_grey)

class Valkyrie(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Siren', 30, 11, hp, siren_price, 'S', libtcod.light_grey)

class Firestarter(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Spark', 35, 10, hp, spark_price, 'S', libtcod.grey)

class Jenner(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Newt', 35, 10, hp, newt_price, 'N', libtcod.grey)

class Ostcout(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Bumblebee', 35, 10, hp, bumblebee_price, 'B', libtcod.grey)

class Panther(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Hornet', 35, 13, hp, hornet_price, 'H', libtcod.grey)

assasin_price       = 3765813
cicada_price        = 3705217
clint_price         = 3572380
hermesII_price      = 3165680
vulcan_price        = 3462900
whitworth_price     = 2912933
blackjack_price     = 3147225
hatchetman_price    = 3129390
phoenixhawk_price   = 4315250
vindicator_price    = 3181083
centurion_price     = 3491500
enforcer_price      = 3536875
hunchback_price     = 3467875
trebuchet_price     = 4293500
dervish_price       = 4989967
griffin_price       = 4957107
shadowhawk_price    = 4539382
wolverine_price     = 4827682

##########
# MEDIUM #
##########

class Assasin(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Assasin', 40, 10, hp, assasin_price, 'A', libtcod.light_green)

class Cicada(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Cicada', 40, 10, hp, cicada_price, 'C', libtcod.light_green)

class Clint(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Clint', 40, 10, hp, clint_price, 'C', libtcod.light_green)

class Hermes_II(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Hermes II', 40, 10, hp, hermesII_price, 'H', libtcod.light_green)

class Vulcan(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Vulcan', 40, 10, hp, vulcan_price, 'V', libtcod.light_green)

class Whitworth(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Whitworth', 40, 10, hp, whitworth_price, 'W', libtcod.light_green)

class Blackjack(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Blackjack', 45, 11, hp, blackjack_price, 'B', libtcod.light_green)

class Hatchetman(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Hatchetman', 45, 14, hp, hatchetman_price, 'T', libtcod.light_green)

class Phoenix_Hawk(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Phoenix Hawk', 45, 10, hp, phoenixhawk_price, 'P', libtcod.light_green)

class Vindicator(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Vindicator', 45, 16, hp, vindicator_price, 'V', libtcod.light_green)

class Centurion(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Centurion', 50, 10, hp, centurion_price, 'N', libtcod.light_green)

class Enforcer(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Enforcer', 50, 12, hp, enforcer_price, 'E', libtcod.light_green)

class Hunchback(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Hunchback', 50, 13, hp, hunchback_price, 'H', libtcod.light_green)

class Trebuchet(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Trebuchet', 50, 10, hp, trebuchet_price, 'T', libtcod.light_green)

class Dervish(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Dervish', 55, 10, hp, dervish_price, 'D', libtcod.light_green)

class Griffin(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Griffin', 55, 12, hp, griffin_price, 'G', libtcod.light_green)

class Shadow_Hawk(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Shadow Hawk', 55, 12, hp, shadowhawk_price, 'S', libtcod.light_green)

class Wolverine(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Wolverine', 55, 12, hp, wolverine_price, 'W', libtcod.light_green)

dragon_price        = 5036800
ostroc_price        = 5025600
ostsol_price        = 5017600
quickdraw_price     = 5514560
rifleman_price      = 4860000
catapult_price      = 5790125
crusader_price      = 5686010
jagermech_price     = 5232425
thunderbolt_price   = 5413760
archer_price        = 6384974
grasshopper_price   = 6024574
warhammer_price     = 6070984
marauder_price      = 6635125
orion_price         = 6674500


#########
# HEAVY #
#########

class Dragon(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Dragon', 60, 10, hp, dragon_price, '"')

class Ostroc(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Ostroc', 60, 15, hp, ostroc_price, '$')

class Ostsol(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Ostsol', 60, 16, hp, ostsol_price, '%')

class Quickdraw(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Quickdraw', 60, 13, hp, quickdraw_price, '#')

class Rifleman(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Rifleman', 60, 10, hp, rifleman_price, '*')

class Catapult(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Catapult', 65, 15, hp, catapult_price, '~')

class Crusader(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Crusader', 65, 10, hp, crusader_price, '-')

class Jagermech(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Jagermech', 65, 10, hp, jagermech_price, '>')

class Thunderbolt(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Thunderbolt', 65, 15, hp, thunderbolt_price, '<')

class Archer(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Archer', 70, 10, hp, archer_price, '@')

class Grasshopper(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Grasshopper', 70, 22, hp, grasshopper_price, '+')

class Warhammer(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Warhammer', 70, 18, hp, warhammer_price, '_')

class Marauder(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Marauder', 75, 16, hp, marauder_price, ';')

class Orion(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Orion', 75, 10, hp, orion_price, ',')

###########
# ASSAULT #
###########

class Awesome(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Awesome', 80, 28, hp, panther_price, '')

class Charger(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Charger', 80, 10, hp, panther_price, '')

class Victor(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Victor', 80, 15, hp, panther_price, '')

class Zeus(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Zeus', 80, 17, hp, panther_price, '')

class Battlemaster(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Battlemaster', 85, 18, hp, panther_price, '')

class Stalker(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Stalker', 85, 20, hp, panther_price, '')

class Cyclops(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Cyclops', 90, 12, hp, panther_price, '')

class Banshee(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Banshee', 95, 16, hp, panther_price, '')

class Atlas(Mech):
     def __init__(self,hp,price):
          Mech.__init__(self,'Atlas', 100, 20, hp, panther_price, '')

def createRandomMech():
     random_number = libtcod.random_get_int(0,1,12)
     probability_pos = 1431

#######
#LIGHT#
#######

     if random_number >= probability_pos-1326 and random_number<= probability_pos-1275:
          return Locust(100)
     if random_number >= probability_pos-1275 and random_number<= probability_pos-1225:
          return Stinger(100)
     if random_number >= probability_pos-1225 and random_number<= probability_pos-1176:
          return Commando(100)
     if random_number >= probability_pos-1176 and random_number<= probability_pos-1128:
          return Javelin(100)
     if random_number >= probability_pos-1128 and random_number<= probability_pos-1081:
          return Spider(100)
     if random_number >= probability_pos-1081 and random_number<= probability_pos-1035:
          return UrbanMech(100)
     if random_number >= probability_pos-1035 and random_number<= probability_pos-990:
          return Valkyrie(100)
     if random_number >= probability_pos-990 and random_number<= probability_pos-946:
          return Firestarter(100)
     if random_number >= probability_pos-946 and random_number<= probability_pos-903:
          return Jenner(100)
     if random_number >= probability_pos-903 and random_number<= probability_pos-861:
          return Ostcout(100)
     if random_number >= probability_pos-861 and random_number<= probability_pos-820:
          return Panther(100)
########
#MEDIUM#
########
     
     if random_number >= probability_pos-820 and random_number<= probability_pos-780:
          return Assasin(100)
     if random_number >= probability_pos-780 and random_number<= probability_pos-741:
          return Cicada(100)
     if random_number >= probability_pos-741 and random_number<= probability_pos-703:
          return Clint(100)
     if random_number >= probability_pos-703 and random_number<= probability_pos-666:
          return Hermes_II(100)
     if random_number >= probability_pos-666 and random_number<= probability_pos-630:
          return Vulcan(100)
     if random_number >= probability_pos-630 and random_number<= probability_pos-595:
          return Whitworth(100)
     if random_number >= probability_pos-595 and random_number<= probability_pos-561:
          return Blackjack(100)
     if random_number >= probability_pos-561 and random_number<= probability_pos-528:
          return Hatchetman(100)
     if random_number >= probability_pos-528 and random_number<= probability_pos-496:
          return Phoenix_Hawk(100)
     if random_number >= probability_pos-496 and random_number<= probability_pos-465:
          return Vindicator(100)
     if random_number >= probability_pos-465 and random_number<= probability_pos-435:
          return Centurion(100)
     if random_number >= probability_pos-435 and random_number<= probability_pos-406:
          return Enforcer(100)
     if random_number >= probability_pos-406 and random_number<= probability_pos-378:
          return Hunchback(100)
     if random_number >= probability_pos-378 and random_number<= probability_pos-351:
          return Trebuchet(100)
     if random_number >= probability_pos-351 and random_number<= probability_pos-325:
          return Dervish(100)
     if random_number >= probability_pos-325 and random_number<= probability_pos-300:
          return Griffin(100)
     if random_number >= probability_pos-300 and random_number<= probability_pos-276:
          return Shadow_Hawk(100)
     if random_number >= probability_pos-276 and random_number<= probability_pos-253:
          return Wolverine(100)
     if random_number >= probability_pos-253 and random_number<= probability_pos-231:

#######
#HEAVY#
#######

          return Dragon(100)
     if random_number >= probability_pos-231 and random_number<= probability_pos-210:
          return Ostroc(100)
     if random_number >= probability_pos-210 and random_number<= probability_pos-190:
          return Ostsol(100)
     if random_number >= probability_pos-190 and random_number<= probability_pos-171:
          return Quickdraw(100)
     if random_number >= probability_pos-171 and random_number<= probability_pos-153:
          return Rifleman(100)
     if random_number >= probability_pos-153 and random_number<= probability_pos-136:
          return Catapult(100)
     if random_number >= probability_pos-136 and random_number<= probability_pos-120:
          return Jagermech(100)
     if random_number >= probability_pos-120 and random_number<= probability_pos-105:
          return Thunderbolt(100)
     if random_number >= probability_pos-105 and random_number<= probability_pos-91:
          return Archer(100)
     if random_number >= probability_pos-91 and random_number<= probability_pos-78:
          return Grasshopper(100)
     if random_number >= probability_pos-76 and random_number<= probability_pos-66:
          return Warhammer(100)
     if random_number >= probability_pos-66 and random_number<= probability_pos-55:
          return Marauder(100)
     if random_number >= probability_pos-55 and random_number<= probability_pos-45:
          return Orion(100)

#########
#ASSAULT#
#########

     if random_number >= probability_pos-45 and random_number<= probability_pos-36:
          return Awesome(100)
     if random_number >= probability_pos-36 and random_number<= probability_pos-28:
          return Charger(100)
     if random_number >= probability_pos-28 and random_number<= probability_pos-21:
          return Victor(100)
     if random_number >= probability_pos-21 and random_number<= probability_pos-15:
          return Zeus(100)
     if random_number >= probability_pos-15 and random_number<= probability_pos-10:
          return Battlemaster(100)
     if random_number >= probability_pos-10 and random_number<= probability_pos-6:
          return Stalker(100)
     if random_number >= probability_pos-6 and random_number<= probability_pos-3:
          return Cyclops(100)
     if random_number >= probability_pos-3 and random_number<= probability_pos-1:
          return Banshee(100)
     if random_number >= probability_pos and random_number<= probability_pos:
          return Atlas(100)


